test-release.sh 13 KB

123456789101112131415161718192021222324252627282930313233343536373839404142434445464748495051525354555657585960616263646566676869707172737475767778798081828384858687888990919293949596979899100101102103104105106107108109110111112113114115116117118119120121122123124125126127128129130131132133134135136137138139140141142143144145146147148149150151152153154155156157158159160161162163164165166167168169170171172173174175176177178179180181182183184185186187188189190191192193194195196197198199200201202203204205206207208209210211212213214215216217218219220221222223224225226227228229230231232233234235236237238239240241242243244245246247248249250251252253254255256257258259260261262263264265266267268269270271272273274275276277278279280281282283284285286287288289290291292293294295296297298299300301302303304305306307308309310311312313314315316317318319320321322323324325326327328329330331332333334335336337338339340341342343344345346347348349350351352353354355356357358359360361362363364365366367368369370371372373374375376377378379380381382383384385386387388389390391392393394395396397398399400401402403404405406407408409410411412413414415416417418419420421422423424425426427428429430431432433434435436437438439440441442443
  1. #!/usr/bin/env bash
  2. #
  3. # MMGen Wallet, a terminal-based cryptocurrency wallet
  4. # Copyright (C)2013-2025 The MMGen Project <mmgen@tuta.io>
  5. # Licensed under the GNU General Public License, Version 3:
  6. # https://www.gnu.org/licenses
  7. # Public project repositories:
  8. # https://github.com/mmgen/mmgen-wallet
  9. # https://gitlab.com/mmgen/mmgen-wallet
  10. # Tested on Linux, Armbian, Raspbian, MSYS2
  11. # cfg.sh must implement:
  12. # list_avail_tests()
  13. # init_groups()
  14. # init_tests()
  15. . 'test/test-release.d/cfg.sh'
  16. run_test() {
  17. set +x
  18. local tests="t_$1" skips="t_$1_skip" continue_on_error="e_$1" have_error=
  19. while read skip test; do
  20. [ "$test" ] || continue
  21. echo "${!skips}" | grep -q $skip && continue
  22. if [ "$LIST_CMDS" ]; then
  23. echo $test
  24. else
  25. test_disp=$YELLOW${test/\#/$RESET$MAGENTA\#}$RESET
  26. if [ "${test:0:1}" == '#' ]; then
  27. echo -e "$test_disp"
  28. else
  29. echo -e "${GREEN}Running:$RESET $test_disp"
  30. eval "$test" || {
  31. echo -e $RED"test-release.sh: test '$CUR_TEST' failed at command '$test'"$RESET
  32. have_error=1
  33. [ "${!continue_on_error}" ] || exit 1
  34. }
  35. fi
  36. fi
  37. done <<<${!tests}
  38. if [ "$have_error" ]; then { echo -e "$RED${!continue_on_error}$RESET"; exit 1; }; fi
  39. }
  40. prompt_skip() {
  41. echo -n "Enter 's' to skip, or ENTER to continue: "; read -n1; echo
  42. [ "$REPLY" == 's' ] && return 0
  43. return 1
  44. }
  45. list_avail_tests() {
  46. echo "AVAILABLE TESTS:"
  47. init_tests
  48. for i in $all_tests; do
  49. z="d_$i"
  50. printf " %-8s - %s\n" $i "${!z}"
  51. done
  52. echo
  53. echo "AVAILABLE TEST GROUPS:"
  54. while read a b c; do
  55. [ "$a" ] && printf " %-8s - %s\n" $a "$c"
  56. done <<<$groups_desc
  57. echo
  58. echo "By default, all tests are run"
  59. }
  60. run_tests() {
  61. [ "$LIST_CMDS" ] || echo "Running tests: $1"
  62. for t in $1; do
  63. desc_id="d_$t" desc=${!desc_id}
  64. if [ "$SKIP_ALT_DEP" ]; then
  65. ok=$(for a in $noalt_tests $noalt_ok_tests; do if [ $t == $a ]; then echo 'ok'; fi; done)
  66. if [ ! "$ok" ]; then
  67. echo -e "${BLUE}Skipping altcoin test '$t'$RESET"
  68. continue
  69. fi
  70. fi
  71. if [ "$LIST_CMDS" ]; then
  72. echo -e "\n### $t: $desc"
  73. else
  74. echo -e "\n${BLUE}Testing:$RESET $GREEN$desc$RESET"
  75. fi
  76. [ "$PAUSE" ] && prompt_skip && continue
  77. CUR_TEST=$t
  78. run_test $t
  79. [ "$LIST_CMDS" ] || echo -e "${BLUE}Finished testing:$RESET $GREEN$desc$RESET"
  80. done
  81. }
  82. check_tests() {
  83. for i in $tests; do
  84. echo "$dfl_tests $extra_tests" | grep -q "\<$i\>" || {
  85. echo "$i: unrecognized argument"
  86. exit 1
  87. }
  88. done
  89. }
  90. remove_skipped_tests() {
  91. tests=$(for t in $tests; do
  92. [ "$(for s in $SKIP_LIST; do [ $t == $s ] && echo y; done)" ] && continue
  93. echo $t
  94. done)
  95. tests=$(echo $tests)
  96. }
  97. list_group_symbols() {
  98. echo -e "Default tests:\n $dfl_tests"
  99. echo -e "Extra tests:\n $extra_tests"
  100. echo -e "'noalt' test group:\n $noalt_tests"
  101. echo -e "'quick' test group:\n $quick_tests"
  102. echo -e "'qskip' test group:\n $qskip_tests"
  103. }
  104. print_ver_hash() {
  105. python3 -m pip freeze | grep "^$repo\>" | sed 's/.*sha256=//' | cut -c 1-12
  106. }
  107. do_typescript() {
  108. if [ "$DARWIN" ]; then script "$1" $2; else script -O "$1" -c "$2"; fi
  109. }
  110. install_package() {
  111. echo -e "${BLUE}Installing package$YELLOW $repo$RESET"
  112. rm -rf build dist *.egg-info
  113. ver=$(print_ver_hash)
  114. echo -e "${BLUE}Currently installed version is$MAGENTA $ver$RESET"
  115. cmd="python3 -m build --no-isolation --wheel --config-setting=quiet $STDOUT_DEVNULL"
  116. echo -e "${BLUE}Executing:$CYAN $cmd$RESET"
  117. eval $cmd
  118. cmd="python3 -m pip $QUIET install --break-system-packages dist/*.whl"
  119. echo -e "${BLUE}Executing:$CYAN $cmd$RESET"
  120. eval $cmd
  121. new_ver=$(print_ver_hash)
  122. if [ "$ver" == "$new_ver" ]; then
  123. echo -ne "${YELLOW}Version hash is unchanged. Force install? (y/N):$RESET "
  124. read -n1
  125. if [ "$REPLY" == 'y' ]; then
  126. echo
  127. cmd="python3 -m pip $QUIET install --break-system-packages --force --no-deps dist/*.whl"
  128. echo -e "${BLUE}Executing:$CYAN $cmd$RESET"
  129. eval $cmd
  130. elif [ "$REPLY" ]; then
  131. echo; return
  132. else
  133. return
  134. fi
  135. fi
  136. new_ver=$(print_ver_hash)
  137. if [ "$ver" == "$new_ver" ]; then
  138. echo -e "${RED}ERROR: version hash is unchanged$RESET"
  139. exit 1
  140. else
  141. echo -e "${GREEN}OK$RESET"
  142. fi
  143. }
  144. do_reexec() {
  145. [ -z "$exec_prog" ] && exec_prog="test/test-release.sh -X $ORIG_ARGS"
  146. if [ "$sdist_dir" ]; then
  147. target_dir=$sdist_dir
  148. elif [ "$clone_dir" ]; then
  149. target_dir="$orig_cwd/.clone-test"
  150. clone_dir=$target_dir
  151. else # TYPESCRIPT=1
  152. do_typescript "$orig_cwd/$typescript_file" "$exec_prog"
  153. return
  154. fi
  155. rm -rf $target_dir
  156. mkdir $target_dir
  157. if [ "$repo" != 'mmgen-wallet' ]; then
  158. echo -e "${BLUE}Cloning repo $MAGENTA'mmgen-wallet'$RESET ${BLUE}to $YELLOW$target_dir/mmgen-wallet$RESET"
  159. mkdir -p "$target_dir/mmgen-wallet"
  160. eval "git clone $orig_cwd/../mmgen-wallet $target_dir/mmgen-wallet $STDOUT_DEVNULL $STDERR_DEVNULL"
  161. fi
  162. if [ "$clone_dir" ]; then
  163. [ "$(git status --porcelain)" ] && VIM_GIT_COMMIT=1 git commit -a
  164. dest="$clone_dir/$repo"
  165. rm -rf $dest
  166. mkdir -p $dest
  167. echo -e "${BLUE}Cloning repo $MAGENTA'$repo'$BLUE to $YELLOW$dest$RESET"
  168. eval "git clone . $dest $STDOUT_DEVNULL $STDERR_DEVNULL"
  169. cd $dest
  170. echo -e "${BLUE}cd -> $YELLOW$PWD$RESET"
  171. fi
  172. if [ "$sdist_dir" ]; then
  173. rm -rf build dist *.egg-info
  174. echo -n 'Building sdist...'
  175. eval "python3 -m build --no-isolation --sdist --config-setting=quiet $STDOUT_DEVNULL"
  176. echo -e "done\n${BLUE}Unpacking sdist archive to $YELLOW$target_dir$RESET"
  177. tar -C $target_dir -zxf dist/*.tar.gz
  178. cd $target_dir/${repo//-/[-_]}-*
  179. echo -e "${BLUE}cd -> $YELLOW$PWD$RESET"
  180. if [ "$clone_dir" ]; then rm -rf $clone_dir; fi
  181. fi
  182. [ -e 'test/init.sh' ] && test/init.sh $VERBOSE_SHORTOPT
  183. echo -e "\n${BLUE}Executing test runner: ${CYAN}test/test-release $ORIG_ARGS$RESET\n"
  184. if [ "$TYPESCRIPT" ]; then
  185. do_typescript "$orig_cwd/$typescript_file" "$exec_prog"
  186. else
  187. eval $exec_prog
  188. fi
  189. }
  190. install_secp256k1_mod_maybe() {
  191. if [[ "$repo" =~ ^mmgen[-_]wallet ]]; then
  192. eval "python3 setup.py build_ext --inplace $STDOUT_DEVNULL"
  193. fi
  194. }
  195. in_nix_environment() {
  196. for path in ${PATH//:/ }; do
  197. realpath -q $path | grep -q '^/nix/store/' && break
  198. done
  199. }
  200. # start execution
  201. set -e
  202. set -o functrace
  203. set -o errtrace
  204. trap 'echo -e "${GREEN}Exiting at user request$RESET"; exit' INT
  205. umask 0022
  206. orig_cwd=$(pwd)
  207. repo=$(basename $orig_cwd)
  208. if [ "$(uname -m)" == 'armv7l' ]; then
  209. ARM32=1
  210. elif [ "$(uname -m)" == 'aarch64' ]; then
  211. ARM64=1
  212. elif [ "$(uname -s)" == 'Darwin' ]; then
  213. DARWIN=1
  214. DISTRO='DARWIN'
  215. elif [ "$MSYSTEM" ] && uname -a | grep -qi 'msys'; then
  216. MSYS2=1
  217. DISTRO='MSYS2'
  218. fi
  219. [ "$ARM32" -o "$ARM64" ] && {
  220. PEXPECT_LONG_TIMEOUT=' --pexpect-timeout=300'
  221. HTTP_LONG_TIMEOUT='MMGEN_HTTP_TIMEOUT=300 '
  222. }
  223. if [ -e '/etc/os-release' ]; then
  224. DISTRO=$(grep '^ID=' '/etc/os-release' | cut -c 4-)
  225. [ "$DISTRO" ] || {
  226. echo 'Unable to determine distro from /etc/os-release. Aborting'
  227. exit 1
  228. }
  229. fi
  230. cmdtest_py='test/cmdtest.py -n'
  231. objtest_py='test/objtest.py'
  232. objattrtest_py='test/objattrtest.py'
  233. modtest_py='test/modtest.py --names --quiet'
  234. daemontest_py='test/daemontest.py --names --quiet'
  235. tooltest_py='test/tooltest.py'
  236. tooltest2_py='test/tooltest2.py --names --quiet'
  237. gentest_py='test/gentest.py --quiet'
  238. scrambletest_py='test/scrambletest.py'
  239. altcoin_mod_opts='--quiet'
  240. mmgen_tool='cmds/mmgen-tool'
  241. pylint='PYTHONPATH=. pylint' # PYTHONPATH required by older Pythons (e.g. v3.9)
  242. python='python3'
  243. rounds=10
  244. typescript_file='test-release.out'
  245. STDOUT_DEVNULL='>/dev/null'
  246. STDERR_DEVNULL='2>/dev/null'
  247. QUIET='--quiet'
  248. ORIG_ARGS=$@
  249. PROGNAME=$(basename $0)
  250. init_groups
  251. while getopts hAbcCdDe:fFILlNOps:StTvVX OPT
  252. do
  253. case "$OPT" in
  254. h) printf " %-16s Test MMGen release\n" "${PROGNAME}:"
  255. echo " USAGE: $PROGNAME [options] [tests or test group]"
  256. echo " OPTIONS: -h Print this help message"
  257. echo " -A Skip tests requiring altcoin modules or daemons"
  258. echo " -b Buffer keypresses for all invocations of 'test/cmdtest.py'"
  259. echo " -c Run tests in coverage mode"
  260. echo " -C Test from cloned repo (can be combined with -S)"
  261. echo " -d Enable Python Development Mode"
  262. echo " -D Run tests in deterministic mode"
  263. echo " -e PROG With -C, -S or -T, execute PROG instead of this script"
  264. echo " -f Speed up the tests by using fewer rounds"
  265. echo " -F Reduce rounds even further"
  266. echo " -I Install the package"
  267. echo " -L List available tests and test groups with description"
  268. echo " -l List the test name symbols"
  269. echo " -N Pass the --no-timings switch to test/cmdtest.py"
  270. echo " -O Use pexpect.spawn rather than popen_spawn where applicable"
  271. echo " -p Pause between tests"
  272. echo " -s LIST Skip tests in LIST (space-separated)"
  273. echo " -S Build sdist distribution, unpack, and run test"
  274. echo " -t Print the tests without running them"
  275. echo " -T Record a typescript of the screen output in '$typescript_file'"
  276. echo " -v Run test/cmdtest.py with '--exact-output' and other commands"
  277. echo " with '--verbose' switch"
  278. echo " -V Run test/cmdtest.py and other commands with '--verbose' switch"
  279. echo
  280. echo " For traceback output and error file support, set the EXEC_WRAPPER_TRACEBACK"
  281. echo " environment variable"
  282. exit ;;
  283. A) SKIP_ALT_DEP=1
  284. cmdtest_py+=" --no-altcoin"
  285. modtest_py+=" --no-altcoin-deps"
  286. daemontest_py+=" --no-altcoin-deps"
  287. scrambletest_py+=" --no-altcoin"
  288. tooltest2_py+=" --no-altcoin" ;;
  289. b) cmdtest_py+=" --buf-keypress" ;;
  290. c) mkdir -p 'test/trace'
  291. touch 'test/trace.acc'
  292. cmdtest_py+=" --coverage"
  293. tooltest_py+=" --coverage"
  294. tooltest2_py+=" --fork --coverage"
  295. scrambletest_py+=" --coverage"
  296. python="python3 -m trace --count --file=test/trace.acc --coverdir=test/trace"
  297. modtest_py="$python $modtest_py"
  298. daemontest_py="$python $daemontest_py"
  299. objtest_py="$python $objtest_py"
  300. objattrtest_py="$python $objattrtest_py"
  301. gentest_py="$python $gentest_py"
  302. mmgen_tool="$python $mmgen_tool" ;&
  303. C) REEXEC=1 clone_dir="$orig_cwd/.cloned-repo" ;;
  304. d) export PYTHONDEVMODE=1
  305. export PYTHONWARNINGS='error' ;;
  306. D) export MMGEN_TEST_SUITE_DETERMINISTIC=1
  307. export MMGEN_DISABLE_COLOR=1 ;;
  308. e) exec_prog=$(realpath $OPTARG) ;;
  309. f) rounds=6 FAST=1 fast_opt='--fast' modtest_py+=" --fast" daemontest_py+=" --fast" ;;
  310. F) rounds=3 FAST=1 fast_opt='--fast' modtest_py+=" --fast" daemontest_py+=" --fast" ;;
  311. I) INSTALL_PACKAGE=1 ;;
  312. L) list_avail_tests; exit ;;
  313. l) list_group_symbols; exit ;;
  314. N) cmdtest_py+=" --no-timings" ;;
  315. O) cmdtest_py+=" --pexpect-spawn" ;;
  316. p) PAUSE=1 ;;
  317. s) SKIP_LIST+=" $OPTARG" ;;
  318. S) REEXEC=1 sdist_dir="$orig_cwd/.sdist-test" ;;
  319. t) LIST_CMDS=1 ;;
  320. T) REEXEC=1 TYPESCRIPT=1 ;;
  321. v) EXACT_OUTPUT=1 cmdtest_py+=" --exact-output" ;&
  322. V) VERBOSE='--verbose' VERBOSE_SHORTOPT='-v' QUIET=''
  323. [ "$EXACT_OUTPUT" ] || cmdtest_py+=" --verbose"
  324. STDOUT_DEVNULL='' STDERR_DEVNULL=''
  325. modtest_py="${modtest_py/--quiet/--verbose}"
  326. daemontest_py="${daemontest_py/--quiet/--verbose}"
  327. altcoin_mod_opts="${altcoin_mod_opts/--quiet/--verbose}"
  328. tooltest2_py="${tooltest2_py/--quiet/--verbose}"
  329. gentest_py="${gentest_py/--quiet/--verbose}"
  330. tooltest_py+=" --verbose"
  331. mmgen_tool+=" --verbose"
  332. objattrtest_py+=" --verbose"
  333. pylint+=" --verbose"
  334. scrambletest_py+=" --verbose" ;;
  335. X) IN_REEXEC=1 ;;
  336. *) exit ;;
  337. esac
  338. done
  339. in_nix_environment && parity --help >/dev/null 2>&1 || SKIP_PARITY=1
  340. [ "$MMGEN_DISABLE_COLOR" -o ! -t 1 ] || {
  341. RED="\e[31;1m" GREEN="\e[32;1m" YELLOW="\e[33;1m" BLUE="\e[34;1m" MAGENTA="\e[35;1m" CYAN="\e[36;1m"
  342. RESET="\e[0m"
  343. }
  344. [ "$REEXEC" -a -z "$IN_REEXEC" ] && { do_reexec; exit; }
  345. [ "$exec_prog" ] && { echo "option -e makes no sense without -C, -S, or -T" ; exit; }
  346. [ "$INSTALL_PACKAGE" ] && { install_package; exit; }
  347. [ "$MSYS2" -a ! "$FAST" ] && tooltest2_py+=' --fork'
  348. [ "$EXACT_OUTPUT" -o "$VERBOSE" ] || objtest_py+=" -S"
  349. shift $((OPTIND-1))
  350. case $1 in
  351. '') tests=$dfl_tests ;;
  352. 'default') tests=$dfl_tests ;;
  353. 'extra') tests=$extra_tests ;;
  354. 'noalt') tests=$noalt_tests
  355. SKIP_ALT_DEP=1
  356. cmdtest_py+=" --no-altcoin"
  357. modtest_py+=" --no-altcoin-deps"
  358. daemontest_py+=" --no-altcoin-deps"
  359. scrambletest_py+=" --no-altcoin" ;;
  360. 'quick') tests=$quick_tests ;;
  361. 'qskip') tests=$qskip_tests ;;
  362. *) tests="$*" ;;
  363. esac
  364. rounds_min=$((rounds / 2))
  365. for n in 2 5 10 20 50 100 200 500 1000; do
  366. eval "rounds${n}x=$((rounds*n))"
  367. done
  368. init_tests
  369. remove_skipped_tests
  370. check_tests
  371. test/clean.py
  372. install_secp256k1_mod_maybe
  373. start_time=$(date +%s)
  374. run_tests "$tests"
  375. elapsed=$(($(date +%s)-start_time))
  376. elapsed_fmt=$(printf %02d:%02d $((elapsed/60)) $((elapsed%60)))
  377. [ "$LIST_CMDS" ] || {
  378. if [ "$MMGEN_TEST_SUITE_DETERMINISTIC" ]; then
  379. echo -e "\n${GREEN}All OK"
  380. else
  381. echo -e "\n${GREEN}All OK. Total elapsed time: $elapsed_fmt$RESET"
  382. fi
  383. }